import { GsAlphaFailMethod, GsAlphaParam, GsAlphaTestMethod, GsColorParam, GsDepthTestMethod, GsFilter, GsStorageFormat, GsWrapMode } from "../ps2/gs_constants.js";
import Blob from "cross-blob";
export declare class MaterialPass {
    shader_type: ShaderType;
    scroll_rate_x: number;
    scroll_rate_y: number;
    texture_log_width: number;
    texture_log_height: number;
    texture_location: number[];
    texture_buffer_width: number;
    texture_format: GsStorageFormat;
    clut_location: number;
    mag_filter: GsFilter;
    min_filter: GsFilter;
    fixed_mipmap: boolean;
    mipmap_l: number;
    mipmap_k: number;
    wrap_h: GsWrapMode;
    wrap_v: GsWrapMode;
    wrap_params: [number, number, number, number];
    alpha_test_on: boolean;
    alpha_test_method: GsAlphaTestMethod;
    alpha_test_ref: number;
    alpha_fail_method: GsAlphaFailMethod;
    dest_alpha_test_on: boolean;
    dest_alpha_test_value: number;
    depth_test_on: boolean;
    depth_test_method: GsDepthTestMethod;
    alpha_blend_a: GsColorParam;
    alpha_blend_b: GsColorParam;
    alpha_blend_c: GsAlphaParam;
    alpha_blend_d: GsColorParam;
    alpha_blend_value: number;
    metallic: boolean;
    animated: boolean;
    animate_num_frames: number;
    animate_num_frames_x: number;
    animate_num_frames_y: number;
    animate_frame_delay: number;
}
export declare class Material {
    texture_file: number;
    passes: MaterialPass[];
}
export declare enum ShaderType {
    Unlit = 0,
    Lit = 1,
    LitRigged = 2,
    UnlitNormals = 4,
    SpecularRigged = 6
}
export declare class MaterialsChunk {
    materials: Material[];
    num_texture_files: number;
    constructor(materials: Material[], num_texture_files: number);
    static from_blob(blob: Blob): Promise<MaterialsChunk>;
    to_blob(): Blob;
}
